
//X轴管脚
const int pin_x_step = 2;
const int pin_x_dir  = 5;

//Y轴管脚
const int pin_y_step = 3;
const int pin_y_dir  = 6;

//Z轴管脚（此例子不给出Z轴，请参考XY轴代码自行写出Z轴代码）
const int pin_z_step = 4;
const int pin_z_dir  = 7;

const int pin_enable = 8;


//激光(也是继电器）
const int pin_larser = 11;

//转速
const int stepTime   = 300;

void setup(){
  
  pinMode(pin_x_step,  OUTPUT);
  pinMode(pin_x_dir,   OUTPUT);
  pinMode(pin_y_step,  OUTPUT);
  pinMode(pin_y_dir,   OUTPUT);
  pinMode(pin_enable,  OUTPUT);
  pinMode(pin_larser,  OUTPUT);
    
  digitalWrite(pin_x_step, LOW);
  digitalWrite(pin_x_dir,  LOW);
  digitalWrite(pin_y_step, LOW);
  digitalWrite(pin_y_dir,  LOW);
  digitalWrite(pin_enable, HIGH);
  
  analogWrite(pin_larser,  0);
}

void oneStepX(int dir)
{
  int time2 = 3;
  int time1 = stepTime - time2;

  if(time1 < 70)
  time1 = 70;

  digitalWrite(pin_x_dir, (dir > 0)?HIGH:LOW);

  delayMicroseconds(time1);
  digitalWrite(pin_x_step, HIGH);
  delayMicroseconds(time2);
  digitalWrite(pin_x_step, LOW);  
}

void oneStepY(int dir)
{
  int time2 = 3;
  int time1 = stepTime - time2;

  if(time1 < 70)
  time1 = 70;

  digitalWrite(pin_y_dir, (dir > 0)?HIGH:LOW);

  delayMicroseconds(time1);
  digitalWrite(pin_y_step, HIGH);
  delayMicroseconds(time2);
  digitalWrite(pin_y_step, LOW);  
}


void loop(){

  //开启电机有效
  digitalWrite(pin_enable, LOW);

  //打开激光
  analogWrite(pin_larser,  255);

  //X轴电机正转
  for(int i=0; i<100; i++)
      oneStepX(1);
  //X轴电机反转
  for(int i=0; i<100; i++)
      oneStepX(-1);

  //关闭激光
  analogWrite(pin_larser,  255);
      
  //Y轴电机正转     
  for(int i=0; i<100; i++)
      oneStepY(1);
  //Y轴电机反转
  for(int i=0; i<100; i++)
      oneStepY(-1);
}
  
