/*
Email:2434316030@qq.com
Nano CNC Controlboard demo
--8kdz.com--

Noticed:
Put AccelStepper Lib into your arduino library first.

请先把AccelStepper复制到Arduino库文件夹
*/

#include <AccelStepper.h>

//The pins of our control board, don't change.
//管脚定义，不要改
#define STEPPERX_DIR_PIN 5
#define STEPPERY_DIR_PIN 6
#define STEPPERZ_DIR_PIN 7

#define STEPPERX_STEP_PIN 2
#define STEPPERY_STEP_PIN 3
#define STEPPERZ_STEP_PIN 4

#define STEPPER_ENABLE_PIN 8

#define XLIMIT_PIN 9
#define YLIMIT_PIN 10
#define ZLIMIT_PIN 12

AccelStepper stepperX(AccelStepper::DRIVER, STEPPERX_STEP_PIN, STEPPERX_DIR_PIN);
AccelStepper stepperY(AccelStepper::DRIVER, STEPPERY_STEP_PIN, STEPPERY_DIR_PIN);
AccelStepper stepperZ(AccelStepper::DRIVER, STEPPERZ_STEP_PIN, STEPPERZ_DIR_PIN);

bool  stopX = false;
bool  stopY = false;

//步进数 假设为200步/1mm
#define ONE_MM_STEP_COUNT 800 

//使三个电机通电
void EnabledMotors(void)
{
  digitalWrite(STEPPER_ENABLE_PIN,0);
}

//释放三个电机
void DisabledMotors(void)
{
  digitalWrite(STEPPER_ENABLE_PIN,1);
}

//检查限位
bool CheckLimit(int vPin)
{
  if(digitalRead(vPin) == 0)
    {
      delay(3);
      if(digitalRead(vPin) == 0)
        return true;
    }
 return false;
}

void setup() {

    //最快速度和加速度，这里设置的比较保守，用皮带传动的可以设置大些。
    
    stepperX.setMaxSpeed(1000.0);
    stepperX.setAcceleration(200.0);

    stepperY.setMaxSpeed(1000.0);
    stepperY.setAcceleration(200.0);

    stepperZ.setMaxSpeed(1000.0);
    stepperZ.setAcceleration(200.0);    

    pinMode(XLIMIT_PIN,INPUT_PULLUP);
    pinMode(YLIMIT_PIN,INPUT_PULLUP);
    pinMode(ZLIMIT_PIN,INPUT_PULLUP);

    pinMode(STEPPER_ENABLE_PIN,OUTPUT);
    EnabledMotors();

    stepperX.moveTo(200*ONE_MM_STEP_COUNT);
    stepperY.moveTo(200*ONE_MM_STEP_COUNT);
    stepperZ.moveTo(200*ONE_MM_STEP_COUNT);
}

void loop() {

  //xy stop when limit, or go to the end.
  //XY 只走一趟，遇到限位停

  if(CheckLimit(XLIMIT_PIN))
    stopX = true;
  
  if(!stopX)
    stepperX.run();

  if(CheckLimit(YLIMIT_PIN))
    stopY = true;

  if(!stopY)
    stepperY.run();

  //Z 来回运动，遇到限位就停，放到限位又继续
  //z go between 0~200mm
  
  if(!CheckLimit(ZLIMIT_PIN)) {
    stepperZ.run();
    if(stepperZ.distanceToGo() == 0){
        stepperZ.moveTo(-stepperZ.currentPosition());
        }
  }
  
}
